#include <at89x52.h>
#include "MyHeader.h"

void MyISR(void) interrupt 0
{
		ISR_LED=~ISR_LED;
		R1=0;R2=R3=R4=1;
		if(C1==0)
		{
			Key=Key_Value[0][0]; //Key='1'
			return;
		}
		if(C2==0)
		{
			Key=Key_Value[0][1];	//Key='2'
			return;
		}
		if(C3==0)
		{
			Key=Key_Value[0][2];	//Key='3'
			return;
		}	

		R2=0;R1=R3=R4=1;
		if(C1==0)
		{
			Key=Key_Value[1][0];	//Key='4'
			return;
		}
		if(C2==0)
		{
			Key=Key_Value[1][1];	//Key='5'
			return;
		}
		if(C3==0)
		{
			Key=Key_Value[1][2];	//Key='6'
			return;
		}

		R3=0;R1=R2=R4=1;
		if(C1==0)
		{
			Key=Key_Value[2][0];	//Key='7'
			return;
		}
		if(C2==0)
		{
			Key=Key_Value[2][1];	//Key='8'
			return;
		}
		if(C3==0)
		{
			Key=Key_Value[2][2];	//Key='9'
			return;
		}
		
		R4=0;R1=R2=R3=1;
		if(C1==0)
		{
			Key=Key_Value[3][0];	//Key='*'
			return;
		}
		if(C2==0)
		{
			Key=Key_Value[3][1];	//Key='0'
			return;
		}
		if(C3==0)
		{
			Key=Key_Value[3][2];	//Key='#'
			return;
		}		
}

void main(void)
{
	P2=0;
	R1=R2=R3=R4=0;
	C1=C2=C3=1;
	IE = 0x81; //Enable INT0 interrupt.
	TCON = 0x01; //Edge-triggered interrupt.
	ISR_LED=0;
  while(1) 
	 {
		 R1=R2=R3=R4=0;
		 P2=Key;
	 }
}